<template>
  <div class="flex items-center justify-center mx-auto">
    <div
      class="w-full flex flex-col gap-4 py-5 !rounded-[5px]"
      :class="shadow ? 'shadow' : ''"
    >
      <div v-if="!entity || entity === 'default'" class="w-full flex flex-col gap-4">
        <div class="flex flex-col sm:flex-row justify-between" :class="titleWrapperClass">
          <slot name="title-content">
            <svn-title h1>
              {{ indexTitle }}
            </svn-title>
          </slot>

          <div class="flex-column">
            <slot name="create-index">
              <svn-button append-icon="mdi-plus" text="New" />
            </slot>
          </div>
        </div>

        <div class="w-full justify-center flex flex-col relative gap-4">
          <slot name="inputs">
            <v-text-field density="compact" variant="outlined" label="Search" class="w-full flex-1" clearable clear-icon="mdi-close" prepend-inner-icon="mdi-magnify" hide-details />
          </slot>

          <slot name="body" />
        </div>
      </div>

      <div v-else-if="entity === 'learn_catalog'" class="w-full flex flex-col">
        <div class="flex flex-col sm:flex-row justify-between mb-16">
          <div class="w-full flex-column gap-4">
            <slot name="title-content" />

            <div class="flex items-center gap-3">
              <div>
                <Icon
                  :icon="indexIcon"
                  width="48"
                  height="48"
                />
              </div>

              <svn-title h1>
                {{ indexTitle }}
              </svn-title>
            </div>

            <svn-text sm>
              {{ indexSubtitle }}
            </svn-text>
          </div>

          <div class="w-full flex-column">
            <slot name="create-index">
              <div class="flex justify-end gap-4">
                <svn-button append-icon="mdi-plus" text="New playlist" variant="outlined" class="w-fit" />

                <svn-button append-icon="mdi-plus" text="New module" />
              </div>
            </slot>
          </div>
        </div>

        <div class="w-full flex flex-col gap-6">
          <slot name="tabs">
            <v-tabs grow align-tabs="start" class="!max-w-[360px] border-b border-b-lightGrey" :height="48">
              <v-tab class="!normal-case" color="primary">
                Tab 1
              </v-tab>

              <v-tab class="!normal-case" color="primary">
                Tab 2
              </v-tab>

              <v-tab class="!normal-case" color="primary">
                Tab 3
              </v-tab>
            </v-tabs>
          </slot>

          <slot name="inputs">
            <div class="w-full flex items-center justify-center gap-4 self-stretch">
              <v-text-field placeholder="Search" prepend-inner-icon="mdi-magnify" variant="outlined" />
            </div>
          </slot>
        </div>
      </div>

      <div v-else-if="entity === 'studio_training'" class="w-full flex flex-col sm:px-0 s:pt-0 gap-2 sm:gap-8">
        <div class="w-full">
          <slot name="inputs">
            <div class="w-[25%] flex items-center justify-center gap-4 self-stretch">
              <v-text-field density="compact" placeholder="Search" prepend-inner-icon="mdi-magnify" variant="outlined" />
            </div>
          </slot>
        </div>

        <div class="w-full flex flex-col gap-4 items-center justify-center">
          <slot name="tabs">
            <v-tabs grow align-tabs="start" class="!max-w-[630px] border-b border-b-lightGrey" :height="48">
              <v-tab class="!normal-case" color="fake-black">
                Tab 1
              </v-tab>

              <v-tab class="!normal-case" color="fake-black">
                Tab 2
              </v-tab>

              <v-tab class="!normal-case" color="fake-black">
                Tab 3
              </v-tab>

              <v-tab class="!normal-case" color="fake-black">
                Tab 4
              </v-tab>

              <v-tab class="!normal-case" color="fake-black">
                Tab 5
              </v-tab>
            </v-tabs>

            <div class="!w-[365px]">
              <v-select density="compact" :items="['Item 1', 'Item 2', 'Item 3']" variant="outlined" label="placeholder" hide-details />
            </div>
          </slot>

          <slot name="body" />
        </div>
      </div>

      <div v-else-if="entity === 'roadmap'" class="w-full flex flex-col gap-8">
        <div class="flex flex-col sm:flex-row justify-between">
          <slot name="title-content">
            <svn-title h1>
              {{ indexTitle }}
            </svn-title>
          </slot>

          <div class="flex-column">
            <slot name="create-index">
              <svn-button append-icon="mdi-plus" text="New Target" />
            </slot>
          </div>
        </div>

        <div class="w-full items-center justify-center flex relative">
          <slot name="tabs">
            <v-tabs grow align-tabs="center" class="!max-w-[360px] border-b border-b-lightGrey" :height="48">
              <v-tab class="!normal-case" color="fake-black">
                Tab 1
              </v-tab>

              <v-tab class="!normal-case" color="fake-black">
                Tab 2
              </v-tab>
            </v-tabs>

            <slot name="inputs">
              <div class="absolute flex-1 gap-2 right-0 w-[30%] hidden xl:flex">
                <v-select density="compact" :items="['Item 1', 'Item 2', 'Item 3']" variant="outlined" label="placeholder" class="w-full" hide-details />

                <v-switch density="compact" color="mediumOrange" label="Deep search" class="w-full" inset hide-details />

                <svn-dots-button v-if="withOptions" />
              </div>
            </slot>
          </slot>

          <slot name="body" />
        </div>
      </div>

      <div v-else-if="entity === 'interviews'" class="w-full flex flex-col gap-8">
        <div class="flex flex-col sm:flex-row justify-between">
          <slot name="title-content">
            <svn-title h1>
              {{ indexTitle }}
            </svn-title>
          </slot>

          <div class="flex-column">
            <slot name="create-index">
              <svn-button append-icon="mdi-plus" text="New Target" />
            </slot>
          </div>
        </div>

        <div class="w-full items-center justify-center flex relative gap-4">
          <slot name="inputs">
            <v-text-field density="compact" variant="outlined" label="Search" class="w-full flex-1" clearable clear-icon="mdi-close" prepend-inner-icon="mdi-magnify" hide-details />

            <div class="flex gap-2 items-center justify-center">
              <div class="!w-[175px]">
                <v-switch density="compact" color="mediumOrange" label="Deep search" inset inline hide-details />
              </div>

              <svn-button variant="outlined" prepend-icon="mingcute:filter-line" text="Filter" />

              <svn-dots-button variant="plain" />
            </div>
          </slot>

          <slot name="body" />
        </div>
      </div>

      <div v-else-if="entity === 'roadmap_targets'" class="w-full flex flex-col gap-8">
        <div class="flex flex-col sm:flex-row justify-between">
          <slot name="title-content">
            <svn-title h1>
              {{ indexTitle }}
            </svn-title>
          </slot>

          <div class="flex-column">
            <slot name="create-index">
              <svn-button append-icon="mdi-plus" text="New Target" />
            </slot>
          </div>
        </div>

        <div class="w-full items-center justify-center flex relative gap-4">
          <slot name="inputs">
            <v-text-field density="compact" variant="outlined" label="Search" class="" clearable clear-icon="mdi-close" prepend-inner-icon="mdi-magnify" hide-details />

            <div class="!w-[175px]">
              <v-switch density="compact" color="mediumOrange" label="Deep search" inset inline hide-details />
            </div>

            <v-select :items="['Item 1', 'item 2', 'Item 3']" density="compact" variant="outlined" label="Select input" class="" hide-details />

            <v-select :items="['Item 1', 'item 2', 'Item 3']" density="compact" variant="outlined" label="Select input" class="" hide-details />

            <svn-text sm>From</svn-text>

            <v-text-field density="compact" variant="outlined" placeholder="jj/mm/aaaa" class="" append-inner-icon="mdi-calendar"  hide-details />

            <svn-text sm>To</svn-text>

            <v-text-field density="compact" variant="outlined" placeholder="jj/mm/aaaa" class="" append-inner-icon="mdi-calendar"  hide-details />

            <svn-dots-button variant="plain" />
          </slot>

          <slot name="body" />
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
import { ref } from "vue";
import { Icon } from "@iconify/vue";
import SvnTitle from "../../components/styles/SvnTitle.vue"
import SvnText from "../../components/styles/SvnText.vue"
import SvnButton from "../../components/button/SvnButton.vue"
import SvnDotsButton from "../../components/SvnDotsButton.vue"

const selectedItems = ref([])

defineProps({
  entity: { type: String, default: "default" },
  indexTitle: { type: String, default: "Title" },
  indexSubtitle: { type: String, default: "Here is a short sentence" },
  indexIcon: { type: String, default: "noto:books" },
  withOptions: { type: Boolean, default: false },
  shadow: { type: Boolean, default: false },
  titleWrapperClass: {type: String, default: "px-6"}
  // tableShowSelect: { type: Boolean, default: false },
  // tableHeaders: { type: Array, default: () => [] },
  // tableItems: { type: Array, default: () => [] },
});
</script>

<style scoped>
.shadow {
  box-shadow: 0px 2px 26px rgba(0, 0, 0, 0.05);
}
</style>
